#include <NewPing.h>
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0
#include "IRremote.h"
#include "LiquidCrystal_I2C.h"
#include <Password.h>

int tempo = 180;
int melody[] = {

  NOTE_E5, 8, NOTE_D5, 8, NOTE_FS4, 4, NOTE_GS4, 4, 
  NOTE_CS5, 8, NOTE_B4, 8, NOTE_D4, 4, NOTE_E4, 4, 
  NOTE_B4, 8, NOTE_A4, 8, NOTE_CS4, 4, NOTE_E4, 4,
  NOTE_A4, 2, 
};
int notes = sizeof(melody) / sizeof(melody[0]) / 2;

int wholenote = (60000 * 4) / tempo;

int divider = 0, noteDuration = 0;

#define Button_0 0xE619FF00
#define Button_1 0xBA45FF00
#define Button_2 0xB946FF00
#define Button_3 0xB847FF00
#define Button_4 0xBB44FF00
#define Button_5 0xBF40FF00
#define Button_6 0xBC43FF00
#define Button_7 0xF807FF00
#define Button_8 0xEA15FF00
#define Button_9 0xF609FF00
#define Button_OK 0xE31CFF00
#define Button_diez 0xF20DFF00
int led = 13;
int pin = 3;
const int buzzer = 9;
int value = 0;
int pirState = LOW;
int motion_detected = 0;
IRrecv IR(5);
#define TRIGGER_PIN 10
#define ECHO_PIN 11
#define MAX_DISTANCE 100
NewPing sonar(TRIGGER_PIN,ECHO_PIN,MAX_DISTANCE);
int PIR_value = 0;
LiquidCrystal_I2C lcd(0x27,16,2);
String password;
String good_password = "1234" ;
void setup() {
  pinMode(led, OUTPUT);
  pinMode(pin, INPUT);
  pinMode(buzzer, OUTPUT);
  IR.enableIRIn();
  lcd.init();
  lcd.backlight();
  lcd.setCursor(3, 0);
  lcd.print("Press OK to");
  lcd.setCursor(0, 1);
  lcd.print("enter the pass!");
  Serial.begin(9600);
}
void ultrasonic() {
  unsigned int dist = sonar.ping_cm();
  if(dist != 0){
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Distance is:");
    Serial.println("Distance is:");
    lcd.setCursor(0, 1);
    Serial.println(dist);
    lcd.print(dist);
  }
  delay(5000);
      if(dist < 10 && dist != 0){
          for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
              divider = melody[thisNote + 1];
               if (divider > 0) {
                   noteDuration = (wholenote) / divider;
               } else if (divider < 0) {
                   noteDuration = (wholenote) / abs(divider);
                   noteDuration *= 1.5;
               }
          tone(buzzer, melody[thisNote], noteDuration * 0.9);
          delay(noteDuration);
          noTone(buzzer);
}
      }

}
void get_pir_data() {
    PIR_value = digitalRead(pin);
    if (PIR_value == HIGH) {
      if (pirState == LOW) {
        Serial.println("Motion detected!");
        lcd.clear();
        lcd.print("Motion detected!");
        motion_detected = 1;
        digitalWrite(led, HIGH);
        pirState = HIGH;
        delay(10);
      }
    } else {
        if (pirState == HIGH){
          pirState = LOW;
          delay(10);
      }
    }  
}

void corectPassword(){
if(motion_detected==0){
    get_pir_data();
  } else {
   static int startedTime = millis();
   ultrasonic();
   if(((millis() - startedTime)  / 1000) > 60){
      digitalWrite(led, LOW);
      motion_detected=0;
      Serial.println(((millis() - startedTime)  / 1000));
      lcd.clear();
      lcd.print("No more motion");
      Serial.println("No more motion");
   }       
  }
}
int try_again = 0;
int pass = 0;
int corect_Password = 0;
void loop() {
int button_remote;
 if(IR.decode()){
  if(IR.decodedIRData.decodedRawData == Button_OK && pass == 0){
        Serial.println("A fost apasat butonul OK");
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Password:");
        lcd.setCursor(0, 1);
        pass = 1;
        password = "";
  }
  if(password.length() < 4){
    try_again = 0;
      if(IR.decodedIRData.decodedRawData == Button_0){
        Serial.print("A fost apasat butonul ");
        button_remote = 0;
        lcd.print("0");
        Serial.println(button_remote);
        password = password + "0";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_1){
        Serial.print("A fost apasat butonul ");
        button_remote = 1;
        lcd.print("1");
        Serial.println(button_remote);
        password = password + "1";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_2){
        Serial.print("A fost apasat butonul ");
        button_remote = 2;
        lcd.print("2");
        Serial.println(button_remote);
        password = password + "2";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_3){
        Serial.print("A fost apasat butonul ");
        button_remote = 3;
        lcd.print("3");
        Serial.println(button_remote);
        password = password + "3";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_4){
       Serial.print("A fost apasat butonul ");
        button_remote = 4;
        lcd.print("4");
        Serial.println(button_remote);
        password = password + "4";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_5){
        Serial.print("A fost apasat butonul ");
        button_remote = 5;
        lcd.print("5");
        Serial.println(button_remote);
        password = password + "5";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_6){
        Serial.print("A fost apasat butonul ");
        button_remote = 6;
        lcd.print("6");
        Serial.println(button_remote);
        password = password + "6";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_7){
        Serial.print("A fost apasat butonul ");
        button_remote = 7;
        lcd.print("7");
        Serial.println(button_remote);
        password = password + "7";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_8){
        Serial.print("A fost apasat butonul ");
        button_remote = 8;
        lcd.print("8");
        Serial.println(button_remote);
        password = password + "8";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
      if(IR.decodedIRData.decodedRawData == Button_9){
        Serial.print("A fost apasat butonul ");
        button_remote = 9;
        lcd.print("9");
        Serial.println(button_remote);
        password = password + "9";
        Serial.print("Parola actuala introdusa: ");
        Serial.println(password);
      }
  }
 
      if(IR.decodedIRData.decodedRawData == Button_OK && pass == 1){
        Serial.println("A fost apasat butonul OK");
        if(password.length() == 4){
        if(password.equals(good_password) == true){
          lcd.clear();
          lcd.print("Parola corecta");
          corect_Password = 1;

        } else {
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Parola incorecta");
          lcd.setCursor(0, 1);
          lcd.print(" # = try again");
          try_again = 1;
          pass = 0;
        }
      }
 }

      if(IR.decodedIRData.decodedRawData == Button_diez && try_again == 1){
        try_again = 0;
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Password:");
        lcd.setCursor(0, 1);
        pass = 1;
        password = "";
      }
      IR.resume();
  
  
 }

 if(corect_Password == 1){
            corectPassword();
 }
 
  
}
